Subject: Re: [babel] Babel over DTLS and UDP ports

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Sun, 02 Jun 2019 22:44:56 +0200

David Schinazi <[email-masked]> writes:

> Now, speaking as implementor of Babel (as opposed to draft author), I
> strongly believe that a new port will make a difference in the success
> of this protocol. Juliusz phrased the reasons why quite well.

+1 (even though I currently have no plans to implement the DTLS
extension)...

-Toke

---

From: Donald Eastlake <[email-masked]>
Date: Fri, 7 Jun 2019 15:35:45 -0400

Hi,

It seems to me that we have good reason to go for two ports. I don't
think the IANA expert is trying to be bureaucratic; people's judgement
can differ as to how hard we should be trying to conserve port number
code points for future protocols and as to how good our reasons are.

I think we should forge ahead with a TBD in the draft for the DTLS
secure port if we can't get one with expert approval and, assuming the
draft is approved by the IESG, we will get a port then.

Thanks,
Donald

PS: I'm not sure I would say it is "usual" for protocols to have two
ports, one for secure usage and one for insecure usage, but it is
"common".
===============================
 Donald E. Eastlake 3rd   +1-508-333-2270 (cell)
 1424 Pro Shop Court, Davenport, FL 33896 USA
 [email-masked]

On Fri, May 31, 2019 at 9:14 AM Juliusz Chroboczek <[email-masked]> wrote:
>
> > When the authors requested the new port from IANA, we received some pushback.
> > The position of the IANA port expert was that UDP ports are a scarce resource
> > and they strongly prefer to not allocate them unless it is necessary.
>
> In a healthy technical organisation, the administration helps the
> technical folks get their stuff done.  An organisation is ossified if the
> bureaucacy feels they have the right to dictate the technical solutions.
>
> If there are technical reasons to use a single port, we should state them.
> Under no circumstances should we agree to change our protocol in order to
> make the bureaucrats happy.
>
> > So the question for the Babel WG is: is the separate port necessary?
>
> Antonin's original implementation implementation used a single port:
>
>   https://datatracker.ietf.org/meeting/101/materials/slides-101-babel-babel-over-dtls-00
>
> > One possible solution could be for us to have unencrypted packets and DTLS
> > packets share the same port. For that we can leverage the fact that all Babel
> > packets start with a first byte set to 42, and say that DTLS packets use the
> > same port, prefixed with 43 instead of 42.
>
> Yes, that's what I was arguing for back in 2018.  However, I was put in
> the minority by a number of wise people:
>
>   - David argued that the whole point of DTLS is to use a standard DTLS
>     stack, and some DTLS stacks don't support using a single port for both
>     encrypted an cleartext traffic;
>   - David pointed out that Apple's DTLS implementation doesn't support
>     this mode of operation;
>   - Donald added that it is usual for IETF protocols to use separate ports.
>
> If the above points no longer stand, then please explain what has changed
> since 2018.
>
> If these points still stand, then it is our duty to make the right
> technical decision, IANA's impotence notwithstanding.  We have a number of
> options:
>
>   - go speak with IANA again, stating clearly that using distinct ports
>     reflects WG consensus;
>   - should that fail, we could use an ephemeral port for DTLS, announce it
>     as a sub-TLV of multicast Hello (recall that DTLS uses unicast only);
>   - should that be considered to fragile, we can publish the draft with no
>     port assignment, and have implementations squat an unallocated port.
>
> > What are people's thoughts?
>
> None that can be expressed without profanity.
>
> (Please have a look at the IANA UDP port registry -- thousands of ports
> have been allocated to completely undocumented obscure protocols, and
> they're refusing to allocate a single port for a standards track document?)
>
> -- Juliusz
>
> _______________________________________________
> babel mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/babel

---

From: Juliusz Chroboczek <[email-masked]>
Date: Fri, 07 Jun 2019 22:37:03 +0200

> I don't think the IANA expert is trying to be bureaucratic;

Sorry if I worded that too strongly.  (To my discharge, it was during exam
season, and I was collapsing under the weight of uncorrected student papers.)

-- Juliusz